$(document).ready(function() {
    // Carga Datos Anuncio
    $('.titulo a').click(function () {
        var id = $(this).data('id');
        console.log(id);
        // Cambiar a ojito
        $('.ver-anuncio-'+id).click();
    });


    $('#modalAnuncioForm').on('show.bs.modal', function (event) {
        var button = $(event.relatedTarget)
        var modal = $(this);

        modal.find('#idAnuncio').val(0);
        modal.find('.input-titulo').val('');
        tinymce.get('anuncioContenido').setContent('');
        modal.find('.text-contenido').val('');

        if (button.data('id') == 0) {
            modal.find('.btn-eliminar').hide();
            modal.find('.btn-editar').html('Crear');
            modal.find('.modal-wait').show();
        }
        else {
            var parametros = {
                id : button.data('id')
            };

            $.ajax({
                data:  parametros,
                url:   '/anuncios/info',
                type:  'post',
                beforeSend: function () {
                },
                success:  function (response) {
                    if (response.status == 'success') {
                        let anuncio = response.anuncio;
                        modal.find('#idAnuncio').val(anuncio.id);
                        modal.find('.input-titulo').val(anuncio.titulo);
                        modal.find('.text-contenido').val(anuncio.contenido);
                        tinymce.get('anuncioContenido').setContent(anuncio.contenido);
                    } else {
                        alert(response.message);
                    }
                }
            });
        }
    });


    $('#modalAnuncioForm #formAnuncio').submit(function( event ) {
        event.preventDefault();
        $('#modalAnuncioForm .btn-editar').click();
    });

    $('#modalAnuncioForm .btn-editar' ).click(function() {
        $('#formAnuncio').find('#anuncioContenido').val(tinymce.get("anuncioContenido").getContent());
        var parametros = $('#formAnuncio').serialize();
        $.ajax({
            data:  parametros,
            url:   '/anuncios/guardar',
            type:  'post',
            beforeSend: function () {
            },
            success:  function (response) {
                if (response.status == 'success') {
                    var id = $('#idAnuncio').val();
                    if (id == 0) {
                        location.reload();
                    }
                    else {
                        let anuncio = $('#anuncio' + id);
                        anuncio.find('.titulo a').html($('.input-titulo').val());
                    }
                    $('#modalAnuncioForm').modal('hide');
                }
                else {
                    alert(response.message);
                    // Mostrar errores en div flash
                }
            }
        });
    });

    $('#modalAnuncioForm .btn-eliminar').click(function() {
        if (confirm('Eliminar')) {
            var id = $('#idAnuncio').val();
            var parametros = {
                id : id
            };
            $.ajax({
                data:  parametros,
                url:   '/anuncios/eliminar',
                type:  'post',
                beforeSend: function () {
                
                },
                success:  function (response) {
                    $('#anuncio' + id).remove();
                    $('#modalAnuncioForm').modal('hide');
                }
            });
        }
    });


    $('#modalAnuncioDetalle').on('show.bs.modal', function (event) {
        var button = $(event.relatedTarget);
        var modal = $(this);

        modal.find('#idAnuncioDetalle').val(0);
        modal.find('.titulo').html('');
        modal.find('.contenido').html('');
        modal.find('.btn-leer').removeAttr('disabled').html('Confirmar lectura');
        modal.find('.lista-lectores').html('');

        var parametros = {
            id : button.data('id')
        };

        var fecha_lectura = '';

        $.ajax({
            data:  parametros,
            url:   '/anuncios/ver',
            type:  'post',
            beforeSend: function () {
            },
            success:  function (response) {
                if (response.status == 'success') {
                    fecha_lectura = response.fecha_lectura;
                    if (isDate(fecha_lectura)) {
                        modal.find('.btn-leer').attr('disabled', 'disabled').html('Lectura confirmada');
                    }
                } else {
                    alert(response.message);
                }
            }
        });

        $.ajax({
            data:  parametros,
            url:   '/anuncios/info',
            type:  'post',
            beforeSend: function () {
            },
            success:  function (response) {
                if (response.status == 'success') {
                    let anuncio = response.anuncio;
                    modal.find('#idAnuncioDetalle').val(anuncio.id);
                    modal.find('.titulo').html(anuncio.titulo);
                    modal.find('.contenido').html(anuncio.contenido);

                    if (typeof anuncio.lectores != "undefined") {
                        for (let lector of anuncio.lectores) {
                            carga_lector(lector);
                        }
                    }

                } else {
                    alert(response.message);
                }
            }
        });
    });

    $('#modalAnuncioDetalle .btn-leer').click(function(event) {
        var button = $(this);
        button.attr('disabled', 'disabled');
        var id = $('#idAnuncioDetalle').val();
        var parametros = {
            id : id
        };
        $.ajax({
            data:  parametros,
            url:   '/anuncios/leer',
            type:  'post',
            beforeSend: function () {
            
            },
            success:  function (response) {
                $('#anuncio' + id).removeClass('sin-lectura');
                button.html('Lectura confirmada');
            }
        });
    });


    // Prevent Bootstrap dialog from blocking focusin
    $(document).on('focusin', function(e) {
        if ($(e.target).closest(".tox-tinymce, .tox-tinymce-aux, .moxman-window, .tam-assetmanager-root").length) {
            e.stopImmediatePropagation();
        }
    });

});

function carga_lector(lector){
    var estados = Array();
    estados[0] = 'No visto';
    estados[1] = 'Visto';
    estados[2] = 'Leído';

    let html = $($.parseHTML($('.lector-copy').html()));

    html.find('.nombre-lector').html(lector.alias);
    html.find('.estado-lector').html(estados[lector.estado]);
    html.find('.fecha-visto').html(fecha(lector.fecha_visto));
    html.find('.fecha-lectura').html(fecha(lector.fecha_lectura));

    if (lector.estado == 0) {
        html.find('.estado-lector').addClass('badge-danger');
    }
    if (lector.estado == 1) {
        html.find('.estado-lector').addClass('badge-warning');
    }
    if (lector.estado == 2) {
        html.find('.estado-lector').addClass('badge-success');
    }

    $('.lista-lectores').append(html);
}